// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: example.proto

package example;

public final class RutaProtos {
  private RutaProtos() {}
  public static void registerAllExtensions(
      com.google.protobuf.ExtensionRegistry registry) {
  }
  public static final class SegmentoCaminho extends
      com.google.protobuf.GeneratedMessage {
    // Use SegmentoCaminho.newBuilder() to construct.
    private SegmentoCaminho() {
      initFields();
    }
    private SegmentoCaminho(boolean noInit) {}
    
    private static final SegmentoCaminho defaultInstance;
    public static SegmentoCaminho getDefaultInstance() {
      return defaultInstance;
    }
    
    public SegmentoCaminho getDefaultInstanceForType() {
      return defaultInstance;
    }
    
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return example.RutaProtos.internal_static_example_SegmentoCaminho_descriptor;
    }
    
    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return example.RutaProtos.internal_static_example_SegmentoCaminho_fieldAccessorTable;
    }
    
    public enum TipoCaminho
        implements com.google.protobuf.ProtocolMessageEnum {
      AVENIDA(0, 0),
      ESTRADA(1, 1),
      ;
      
      
      public final int getNumber() { return value; }
      
      public static TipoCaminho valueOf(int value) {
        switch (value) {
          case 0: return AVENIDA;
          case 1: return ESTRADA;
          default: return null;
        }
      }
      
      public static com.google.protobuf.Internal.EnumLiteMap<TipoCaminho>
          internalGetValueMap() {
        return internalValueMap;
      }
      private static com.google.protobuf.Internal.EnumLiteMap<TipoCaminho>
          internalValueMap =
            new com.google.protobuf.Internal.EnumLiteMap<TipoCaminho>() {
              public TipoCaminho findValueByNumber(int number) {
                return TipoCaminho.valueOf(number)
      ;        }
            };
      
      public final com.google.protobuf.Descriptors.EnumValueDescriptor
          getValueDescriptor() {
        return getDescriptor().getValues().get(index);
      }
      public final com.google.protobuf.Descriptors.EnumDescriptor
          getDescriptorForType() {
        return getDescriptor();
      }
      public static final com.google.protobuf.Descriptors.EnumDescriptor
          getDescriptor() {
        return example.RutaProtos.SegmentoCaminho.getDescriptor().getEnumTypes().get(0);
      }
      
      private static final TipoCaminho[] VALUES = {
        AVENIDA, ESTRADA, 
      };
      public static TipoCaminho valueOf(
          com.google.protobuf.Descriptors.EnumValueDescriptor desc) {
        if (desc.getType() != getDescriptor()) {
          throw new java.lang.IllegalArgumentException(
            "EnumValueDescriptor is not for this type.");
        }
        return VALUES[desc.getIndex()];
      }
      private final int index;
      private final int value;
      private TipoCaminho(int index, int value) {
        this.index = index;
        this.value = value;
      }
      
      static {
        example.RutaProtos.getDescriptor();
      }
      
      // @@protoc_insertion_point(enum_scope:example.SegmentoCaminho.TipoCaminho)
    }
    
    public static final class Coordenada extends
        com.google.protobuf.GeneratedMessage {
      // Use Coordenada.newBuilder() to construct.
      private Coordenada() {
        initFields();
      }
      private Coordenada(boolean noInit) {}
      
      private static final Coordenada defaultInstance;
      public static Coordenada getDefaultInstance() {
        return defaultInstance;
      }
      
      public Coordenada getDefaultInstanceForType() {
        return defaultInstance;
      }
      
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return example.RutaProtos.internal_static_example_SegmentoCaminho_Coordenada_descriptor;
      }
      
      protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return example.RutaProtos.internal_static_example_SegmentoCaminho_Coordenada_fieldAccessorTable;
      }
      
      // required int64 pos_x = 1;
      public static final int POS_X_FIELD_NUMBER = 1;
      private boolean hasPosX;
      private long posX_ = 0L;
      public boolean hasPosX() { return hasPosX; }
      public long getPosX() { return posX_; }
      
      // required int64 pos_y = 2;
      public static final int POS_Y_FIELD_NUMBER = 2;
      private boolean hasPosY;
      private long posY_ = 0L;
      public boolean hasPosY() { return hasPosY; }
      public long getPosY() { return posY_; }
      
      private void initFields() {
      }
      public final boolean isInitialized() {
        if (!hasPosX) return false;
        if (!hasPosY) return false;
        return true;
      }
      
      public void writeTo(com.google.protobuf.CodedOutputStream output)
                          throws java.io.IOException {
        getSerializedSize();
        if (hasPosX()) {
          output.writeInt64(1, getPosX());
        }
        if (hasPosY()) {
          output.writeInt64(2, getPosY());
        }
        getUnknownFields().writeTo(output);
      }
      
      private int memoizedSerializedSize = -1;
      public int getSerializedSize() {
        int size = memoizedSerializedSize;
        if (size != -1) return size;
      
        size = 0;
        if (hasPosX()) {
          size += com.google.protobuf.CodedOutputStream
            .computeInt64Size(1, getPosX());
        }
        if (hasPosY()) {
          size += com.google.protobuf.CodedOutputStream
            .computeInt64Size(2, getPosY());
        }
        size += getUnknownFields().getSerializedSize();
        memoizedSerializedSize = size;
        return size;
      }
      
      public static example.RutaProtos.SegmentoCaminho.Coordenada parseFrom(
          com.google.protobuf.ByteString data)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return newBuilder().mergeFrom(data).buildParsed();
      }
      public static example.RutaProtos.SegmentoCaminho.Coordenada parseFrom(
          com.google.protobuf.ByteString data,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return newBuilder().mergeFrom(data, extensionRegistry)
                 .buildParsed();
      }
      public static example.RutaProtos.SegmentoCaminho.Coordenada parseFrom(byte[] data)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return newBuilder().mergeFrom(data).buildParsed();
      }
      public static example.RutaProtos.SegmentoCaminho.Coordenada parseFrom(
          byte[] data,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return newBuilder().mergeFrom(data, extensionRegistry)
                 .buildParsed();
      }
      public static example.RutaProtos.SegmentoCaminho.Coordenada parseFrom(java.io.InputStream input)
          throws java.io.IOException {
        return newBuilder().mergeFrom(input).buildParsed();
      }
      public static example.RutaProtos.SegmentoCaminho.Coordenada parseFrom(
          java.io.InputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        return newBuilder().mergeFrom(input, extensionRegistry)
                 .buildParsed();
      }
      public static example.RutaProtos.SegmentoCaminho.Coordenada parseDelimitedFrom(java.io.InputStream input)
          throws java.io.IOException {
        Builder builder = newBuilder();
        if (builder.mergeDelimitedFrom(input)) {
          return builder.buildParsed();
        } else {
          return null;
        }
      }
      public static example.RutaProtos.SegmentoCaminho.Coordenada parseDelimitedFrom(
          java.io.InputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        Builder builder = newBuilder();
        if (builder.mergeDelimitedFrom(input, extensionRegistry)) {
          return builder.buildParsed();
        } else {
          return null;
        }
      }
      public static example.RutaProtos.SegmentoCaminho.Coordenada parseFrom(
          com.google.protobuf.CodedInputStream input)
          throws java.io.IOException {
        return newBuilder().mergeFrom(input).buildParsed();
      }
      public static example.RutaProtos.SegmentoCaminho.Coordenada parseFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        return newBuilder().mergeFrom(input, extensionRegistry)
                 .buildParsed();
      }
      
      public static Builder newBuilder() { return Builder.create(); }
      public Builder newBuilderForType() { return newBuilder(); }
      public static Builder newBuilder(example.RutaProtos.SegmentoCaminho.Coordenada prototype) {
        return newBuilder().mergeFrom(prototype);
      }
      public Builder toBuilder() { return newBuilder(this); }
      
      public static final class Builder extends
          com.google.protobuf.GeneratedMessage.Builder<Builder> {
        private example.RutaProtos.SegmentoCaminho.Coordenada result;
        
        // Construct using example.RutaProtos.SegmentoCaminho.Coordenada.newBuilder()
        private Builder() {}
        
        private static Builder create() {
          Builder builder = new Builder();
          builder.result = new example.RutaProtos.SegmentoCaminho.Coordenada();
          return builder;
        }
        
        protected example.RutaProtos.SegmentoCaminho.Coordenada internalGetResult() {
          return result;
        }
        
        public Builder clear() {
          if (result == null) {
            throw new IllegalStateException(
              "Cannot call clear() after build().");
          }
          result = new example.RutaProtos.SegmentoCaminho.Coordenada();
          return this;
        }
        
        public Builder clone() {
          return create().mergeFrom(result);
        }
        
        public com.google.protobuf.Descriptors.Descriptor
            getDescriptorForType() {
          return example.RutaProtos.SegmentoCaminho.Coordenada.getDescriptor();
        }
        
        public example.RutaProtos.SegmentoCaminho.Coordenada getDefaultInstanceForType() {
          return example.RutaProtos.SegmentoCaminho.Coordenada.getDefaultInstance();
        }
        
        public boolean isInitialized() {
          return result.isInitialized();
        }
        public example.RutaProtos.SegmentoCaminho.Coordenada build() {
          if (result != null && !isInitialized()) {
            throw newUninitializedMessageException(result);
          }
          return buildPartial();
        }
        
        private example.RutaProtos.SegmentoCaminho.Coordenada buildParsed()
            throws com.google.protobuf.InvalidProtocolBufferException {
          if (!isInitialized()) {
            throw newUninitializedMessageException(
              result).asInvalidProtocolBufferException();
          }
          return buildPartial();
        }
        
        public example.RutaProtos.SegmentoCaminho.Coordenada buildPartial() {
          if (result == null) {
            throw new IllegalStateException(
              "build() has already been called on this Builder.");
          }
          example.RutaProtos.SegmentoCaminho.Coordenada returnMe = result;
          result = null;
          return returnMe;
        }
        
        public Builder mergeFrom(com.google.protobuf.Message other) {
          if (other instanceof example.RutaProtos.SegmentoCaminho.Coordenada) {
            return mergeFrom((example.RutaProtos.SegmentoCaminho.Coordenada)other);
          } else {
            super.mergeFrom(other);
            return this;
          }
        }
        
        public Builder mergeFrom(example.RutaProtos.SegmentoCaminho.Coordenada other) {
          if (other == example.RutaProtos.SegmentoCaminho.Coordenada.getDefaultInstance()) return this;
          if (other.hasPosX()) {
            setPosX(other.getPosX());
          }
          if (other.hasPosY()) {
            setPosY(other.getPosY());
          }
          this.mergeUnknownFields(other.getUnknownFields());
          return this;
        }
        
        public Builder mergeFrom(
            com.google.protobuf.CodedInputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws java.io.IOException {
          com.google.protobuf.UnknownFieldSet.Builder unknownFields =
            com.google.protobuf.UnknownFieldSet.newBuilder(
              this.getUnknownFields());
          while (true) {
            int tag = input.readTag();
            switch (tag) {
              case 0:
                this.setUnknownFields(unknownFields.build());
                return this;
              default: {
                if (!parseUnknownField(input, unknownFields,
                                       extensionRegistry, tag)) {
                  this.setUnknownFields(unknownFields.build());
                  return this;
                }
                break;
              }
              case 8: {
                setPosX(input.readInt64());
                break;
              }
              case 16: {
                setPosY(input.readInt64());
                break;
              }
            }
          }
        }
        
        
        // required int64 pos_x = 1;
        public boolean hasPosX() {
          return result.hasPosX();
        }
        public long getPosX() {
          return result.getPosX();
        }
        public Builder setPosX(long value) {
          result.hasPosX = true;
          result.posX_ = value;
          return this;
        }
        public Builder clearPosX() {
          result.hasPosX = false;
          result.posX_ = 0L;
          return this;
        }
        
        // required int64 pos_y = 2;
        public boolean hasPosY() {
          return result.hasPosY();
        }
        public long getPosY() {
          return result.getPosY();
        }
        public Builder setPosY(long value) {
          result.hasPosY = true;
          result.posY_ = value;
          return this;
        }
        public Builder clearPosY() {
          result.hasPosY = false;
          result.posY_ = 0L;
          return this;
        }
        
        // @@protoc_insertion_point(builder_scope:example.SegmentoCaminho.Coordenada)
      }
      
      static {
        defaultInstance = new Coordenada(true);
        example.RutaProtos.internalForceInit();
        defaultInstance.initFields();
      }
      
      // @@protoc_insertion_point(class_scope:example.SegmentoCaminho.Coordenada)
    }
    
    // required int32 id = 1;
    public static final int ID_FIELD_NUMBER = 1;
    private boolean hasId;
    private int id_ = 0;
    public boolean hasId() { return hasId; }
    public int getId() { return id_; }
    
    // required .example.SegmentoCaminho.TipoCaminho tipo = 2;
    public static final int TIPO_FIELD_NUMBER = 2;
    private boolean hasTipo;
    private example.RutaProtos.SegmentoCaminho.TipoCaminho tipo_;
    public boolean hasTipo() { return hasTipo; }
    public example.RutaProtos.SegmentoCaminho.TipoCaminho getTipo() { return tipo_; }
    
    // optional string nome = 3;
    public static final int NOME_FIELD_NUMBER = 3;
    private boolean hasNome;
    private java.lang.String nome_ = "";
    public boolean hasNome() { return hasNome; }
    public java.lang.String getNome() { return nome_; }
    
    // required .example.SegmentoCaminho.Coordenada inicio = 4;
    public static final int INICIO_FIELD_NUMBER = 4;
    private boolean hasInicio;
    private example.RutaProtos.SegmentoCaminho.Coordenada inicio_;
    public boolean hasInicio() { return hasInicio; }
    public example.RutaProtos.SegmentoCaminho.Coordenada getInicio() { return inicio_; }
    
    // required .example.SegmentoCaminho.Coordenada fin = 5;
    public static final int FIN_FIELD_NUMBER = 5;
    private boolean hasFin;
    private example.RutaProtos.SegmentoCaminho.Coordenada fin_;
    public boolean hasFin() { return hasFin; }
    public example.RutaProtos.SegmentoCaminho.Coordenada getFin() { return fin_; }
    
    private void initFields() {
      tipo_ = example.RutaProtos.SegmentoCaminho.TipoCaminho.AVENIDA;
      inicio_ = example.RutaProtos.SegmentoCaminho.Coordenada.getDefaultInstance();
      fin_ = example.RutaProtos.SegmentoCaminho.Coordenada.getDefaultInstance();
    }
    public final boolean isInitialized() {
      if (!hasId) return false;
      if (!hasTipo) return false;
      if (!hasInicio) return false;
      if (!hasFin) return false;
      if (!getInicio().isInitialized()) return false;
      if (!getFin().isInitialized()) return false;
      return true;
    }
    
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      getSerializedSize();
      if (hasId()) {
        output.writeInt32(1, getId());
      }
      if (hasTipo()) {
        output.writeEnum(2, getTipo().getNumber());
      }
      if (hasNome()) {
        output.writeString(3, getNome());
      }
      if (hasInicio()) {
        output.writeMessage(4, getInicio());
      }
      if (hasFin()) {
        output.writeMessage(5, getFin());
      }
      getUnknownFields().writeTo(output);
    }
    
    private int memoizedSerializedSize = -1;
    public int getSerializedSize() {
      int size = memoizedSerializedSize;
      if (size != -1) return size;
    
      size = 0;
      if (hasId()) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(1, getId());
      }
      if (hasTipo()) {
        size += com.google.protobuf.CodedOutputStream
          .computeEnumSize(2, getTipo().getNumber());
      }
      if (hasNome()) {
        size += com.google.protobuf.CodedOutputStream
          .computeStringSize(3, getNome());
      }
      if (hasInicio()) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(4, getInicio());
      }
      if (hasFin()) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(5, getFin());
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSerializedSize = size;
      return size;
    }
    
    public static example.RutaProtos.SegmentoCaminho parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data).buildParsed();
    }
    public static example.RutaProtos.SegmentoCaminho parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data, extensionRegistry)
               .buildParsed();
    }
    public static example.RutaProtos.SegmentoCaminho parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data).buildParsed();
    }
    public static example.RutaProtos.SegmentoCaminho parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data, extensionRegistry)
               .buildParsed();
    }
    public static example.RutaProtos.SegmentoCaminho parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input).buildParsed();
    }
    public static example.RutaProtos.SegmentoCaminho parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input, extensionRegistry)
               .buildParsed();
    }
    public static example.RutaProtos.SegmentoCaminho parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      Builder builder = newBuilder();
      if (builder.mergeDelimitedFrom(input)) {
        return builder.buildParsed();
      } else {
        return null;
      }
    }
    public static example.RutaProtos.SegmentoCaminho parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      Builder builder = newBuilder();
      if (builder.mergeDelimitedFrom(input, extensionRegistry)) {
        return builder.buildParsed();
      } else {
        return null;
      }
    }
    public static example.RutaProtos.SegmentoCaminho parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input).buildParsed();
    }
    public static example.RutaProtos.SegmentoCaminho parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input, extensionRegistry)
               .buildParsed();
    }
    
    public static Builder newBuilder() { return Builder.create(); }
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder(example.RutaProtos.SegmentoCaminho prototype) {
      return newBuilder().mergeFrom(prototype);
    }
    public Builder toBuilder() { return newBuilder(this); }
    
    public static final class Builder extends
        com.google.protobuf.GeneratedMessage.Builder<Builder> {
      private example.RutaProtos.SegmentoCaminho result;
      
      // Construct using example.RutaProtos.SegmentoCaminho.newBuilder()
      private Builder() {}
      
      private static Builder create() {
        Builder builder = new Builder();
        builder.result = new example.RutaProtos.SegmentoCaminho();
        return builder;
      }
      
      protected example.RutaProtos.SegmentoCaminho internalGetResult() {
        return result;
      }
      
      public Builder clear() {
        if (result == null) {
          throw new IllegalStateException(
            "Cannot call clear() after build().");
        }
        result = new example.RutaProtos.SegmentoCaminho();
        return this;
      }
      
      public Builder clone() {
        return create().mergeFrom(result);
      }
      
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return example.RutaProtos.SegmentoCaminho.getDescriptor();
      }
      
      public example.RutaProtos.SegmentoCaminho getDefaultInstanceForType() {
        return example.RutaProtos.SegmentoCaminho.getDefaultInstance();
      }
      
      public boolean isInitialized() {
        return result.isInitialized();
      }
      public example.RutaProtos.SegmentoCaminho build() {
        if (result != null && !isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return buildPartial();
      }
      
      private example.RutaProtos.SegmentoCaminho buildParsed()
          throws com.google.protobuf.InvalidProtocolBufferException {
        if (!isInitialized()) {
          throw newUninitializedMessageException(
            result).asInvalidProtocolBufferException();
        }
        return buildPartial();
      }
      
      public example.RutaProtos.SegmentoCaminho buildPartial() {
        if (result == null) {
          throw new IllegalStateException(
            "build() has already been called on this Builder.");
        }
        example.RutaProtos.SegmentoCaminho returnMe = result;
        result = null;
        return returnMe;
      }
      
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof example.RutaProtos.SegmentoCaminho) {
          return mergeFrom((example.RutaProtos.SegmentoCaminho)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }
      
      public Builder mergeFrom(example.RutaProtos.SegmentoCaminho other) {
        if (other == example.RutaProtos.SegmentoCaminho.getDefaultInstance()) return this;
        if (other.hasId()) {
          setId(other.getId());
        }
        if (other.hasTipo()) {
          setTipo(other.getTipo());
        }
        if (other.hasNome()) {
          setNome(other.getNome());
        }
        if (other.hasInicio()) {
          mergeInicio(other.getInicio());
        }
        if (other.hasFin()) {
          mergeFin(other.getFin());
        }
        this.mergeUnknownFields(other.getUnknownFields());
        return this;
      }
      
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          com.google.protobuf.UnknownFieldSet.newBuilder(
            this.getUnknownFields());
        while (true) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              this.setUnknownFields(unknownFields.build());
              return this;
            default: {
              if (!parseUnknownField(input, unknownFields,
                                     extensionRegistry, tag)) {
                this.setUnknownFields(unknownFields.build());
                return this;
              }
              break;
            }
            case 8: {
              setId(input.readInt32());
              break;
            }
            case 16: {
              int rawValue = input.readEnum();
              example.RutaProtos.SegmentoCaminho.TipoCaminho value = example.RutaProtos.SegmentoCaminho.TipoCaminho.valueOf(rawValue);
              if (value == null) {
                unknownFields.mergeVarintField(2, rawValue);
              } else {
                setTipo(value);
              }
              break;
            }
            case 26: {
              setNome(input.readString());
              break;
            }
            case 34: {
              example.RutaProtos.SegmentoCaminho.Coordenada.Builder subBuilder = example.RutaProtos.SegmentoCaminho.Coordenada.newBuilder();
              if (hasInicio()) {
                subBuilder.mergeFrom(getInicio());
              }
              input.readMessage(subBuilder, extensionRegistry);
              setInicio(subBuilder.buildPartial());
              break;
            }
            case 42: {
              example.RutaProtos.SegmentoCaminho.Coordenada.Builder subBuilder = example.RutaProtos.SegmentoCaminho.Coordenada.newBuilder();
              if (hasFin()) {
                subBuilder.mergeFrom(getFin());
              }
              input.readMessage(subBuilder, extensionRegistry);
              setFin(subBuilder.buildPartial());
              break;
            }
          }
        }
      }
      
      
      // required int32 id = 1;
      public boolean hasId() {
        return result.hasId();
      }
      public int getId() {
        return result.getId();
      }
      public Builder setId(int value) {
        result.hasId = true;
        result.id_ = value;
        return this;
      }
      public Builder clearId() {
        result.hasId = false;
        result.id_ = 0;
        return this;
      }
      
      // required .example.SegmentoCaminho.TipoCaminho tipo = 2;
      public boolean hasTipo() {
        return result.hasTipo();
      }
      public example.RutaProtos.SegmentoCaminho.TipoCaminho getTipo() {
        return result.getTipo();
      }
      public Builder setTipo(example.RutaProtos.SegmentoCaminho.TipoCaminho value) {
        if (value == null) {
          throw new NullPointerException();
        }
        result.hasTipo = true;
        result.tipo_ = value;
        return this;
      }
      public Builder clearTipo() {
        result.hasTipo = false;
        result.tipo_ = example.RutaProtos.SegmentoCaminho.TipoCaminho.AVENIDA;
        return this;
      }
      
      // optional string nome = 3;
      public boolean hasNome() {
        return result.hasNome();
      }
      public java.lang.String getNome() {
        return result.getNome();
      }
      public Builder setNome(java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  result.hasNome = true;
        result.nome_ = value;
        return this;
      }
      public Builder clearNome() {
        result.hasNome = false;
        result.nome_ = getDefaultInstance().getNome();
        return this;
      }
      
      // required .example.SegmentoCaminho.Coordenada inicio = 4;
      public boolean hasInicio() {
        return result.hasInicio();
      }
      public example.RutaProtos.SegmentoCaminho.Coordenada getInicio() {
        return result.getInicio();
      }
      public Builder setInicio(example.RutaProtos.SegmentoCaminho.Coordenada value) {
        if (value == null) {
          throw new NullPointerException();
        }
        result.hasInicio = true;
        result.inicio_ = value;
        return this;
      }
      public Builder setInicio(example.RutaProtos.SegmentoCaminho.Coordenada.Builder builderForValue) {
        result.hasInicio = true;
        result.inicio_ = builderForValue.build();
        return this;
      }
      public Builder mergeInicio(example.RutaProtos.SegmentoCaminho.Coordenada value) {
        if (result.hasInicio() &&
            result.inicio_ != example.RutaProtos.SegmentoCaminho.Coordenada.getDefaultInstance()) {
          result.inicio_ =
            example.RutaProtos.SegmentoCaminho.Coordenada.newBuilder(result.inicio_).mergeFrom(value).buildPartial();
        } else {
          result.inicio_ = value;
        }
        result.hasInicio = true;
        return this;
      }
      public Builder clearInicio() {
        result.hasInicio = false;
        result.inicio_ = example.RutaProtos.SegmentoCaminho.Coordenada.getDefaultInstance();
        return this;
      }
      
      // required .example.SegmentoCaminho.Coordenada fin = 5;
      public boolean hasFin() {
        return result.hasFin();
      }
      public example.RutaProtos.SegmentoCaminho.Coordenada getFin() {
        return result.getFin();
      }
      public Builder setFin(example.RutaProtos.SegmentoCaminho.Coordenada value) {
        if (value == null) {
          throw new NullPointerException();
        }
        result.hasFin = true;
        result.fin_ = value;
        return this;
      }
      public Builder setFin(example.RutaProtos.SegmentoCaminho.Coordenada.Builder builderForValue) {
        result.hasFin = true;
        result.fin_ = builderForValue.build();
        return this;
      }
      public Builder mergeFin(example.RutaProtos.SegmentoCaminho.Coordenada value) {
        if (result.hasFin() &&
            result.fin_ != example.RutaProtos.SegmentoCaminho.Coordenada.getDefaultInstance()) {
          result.fin_ =
            example.RutaProtos.SegmentoCaminho.Coordenada.newBuilder(result.fin_).mergeFrom(value).buildPartial();
        } else {
          result.fin_ = value;
        }
        result.hasFin = true;
        return this;
      }
      public Builder clearFin() {
        result.hasFin = false;
        result.fin_ = example.RutaProtos.SegmentoCaminho.Coordenada.getDefaultInstance();
        return this;
      }
      
      // @@protoc_insertion_point(builder_scope:example.SegmentoCaminho)
    }
    
    static {
      defaultInstance = new SegmentoCaminho(true);
      example.RutaProtos.internalForceInit();
      defaultInstance.initFields();
    }
    
    // @@protoc_insertion_point(class_scope:example.SegmentoCaminho)
  }
  
  public static final class Ruta extends
      com.google.protobuf.GeneratedMessage {
    // Use Ruta.newBuilder() to construct.
    private Ruta() {
      initFields();
    }
    private Ruta(boolean noInit) {}
    
    private static final Ruta defaultInstance;
    public static Ruta getDefaultInstance() {
      return defaultInstance;
    }
    
    public Ruta getDefaultInstanceForType() {
      return defaultInstance;
    }
    
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return example.RutaProtos.internal_static_example_Ruta_descriptor;
    }
    
    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return example.RutaProtos.internal_static_example_Ruta_fieldAccessorTable;
    }
    
    // required int32 id = 1;
    public static final int ID_FIELD_NUMBER = 1;
    private boolean hasId;
    private int id_ = 0;
    public boolean hasId() { return hasId; }
    public int getId() { return id_; }
    
    // repeated .example.SegmentoCaminho segmentos = 2;
    public static final int SEGMENTOS_FIELD_NUMBER = 2;
    private java.util.List<example.RutaProtos.SegmentoCaminho> segmentos_ =
      java.util.Collections.emptyList();
    public java.util.List<example.RutaProtos.SegmentoCaminho> getSegmentosList() {
      return segmentos_;
    }
    public int getSegmentosCount() { return segmentos_.size(); }
    public example.RutaProtos.SegmentoCaminho getSegmentos(int index) {
      return segmentos_.get(index);
    }
    
    private void initFields() {
    }
    public final boolean isInitialized() {
      if (!hasId) return false;
      for (example.RutaProtos.SegmentoCaminho element : getSegmentosList()) {
        if (!element.isInitialized()) return false;
      }
      return true;
    }
    
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      getSerializedSize();
      if (hasId()) {
        output.writeInt32(1, getId());
      }
      for (example.RutaProtos.SegmentoCaminho element : getSegmentosList()) {
        output.writeMessage(2, element);
      }
      getUnknownFields().writeTo(output);
    }
    
    private int memoizedSerializedSize = -1;
    public int getSerializedSize() {
      int size = memoizedSerializedSize;
      if (size != -1) return size;
    
      size = 0;
      if (hasId()) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(1, getId());
      }
      for (example.RutaProtos.SegmentoCaminho element : getSegmentosList()) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(2, element);
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSerializedSize = size;
      return size;
    }
    
    public static example.RutaProtos.Ruta parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data).buildParsed();
    }
    public static example.RutaProtos.Ruta parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data, extensionRegistry)
               .buildParsed();
    }
    public static example.RutaProtos.Ruta parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data).buildParsed();
    }
    public static example.RutaProtos.Ruta parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data, extensionRegistry)
               .buildParsed();
    }
    public static example.RutaProtos.Ruta parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input).buildParsed();
    }
    public static example.RutaProtos.Ruta parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input, extensionRegistry)
               .buildParsed();
    }
    public static example.RutaProtos.Ruta parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      Builder builder = newBuilder();
      if (builder.mergeDelimitedFrom(input)) {
        return builder.buildParsed();
      } else {
        return null;
      }
    }
    public static example.RutaProtos.Ruta parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      Builder builder = newBuilder();
      if (builder.mergeDelimitedFrom(input, extensionRegistry)) {
        return builder.buildParsed();
      } else {
        return null;
      }
    }
    public static example.RutaProtos.Ruta parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input).buildParsed();
    }
    public static example.RutaProtos.Ruta parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input, extensionRegistry)
               .buildParsed();
    }
    
    public static Builder newBuilder() { return Builder.create(); }
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder(example.RutaProtos.Ruta prototype) {
      return newBuilder().mergeFrom(prototype);
    }
    public Builder toBuilder() { return newBuilder(this); }
    
    public static final class Builder extends
        com.google.protobuf.GeneratedMessage.Builder<Builder> {
      private example.RutaProtos.Ruta result;
      
      // Construct using example.RutaProtos.Ruta.newBuilder()
      private Builder() {}
      
      private static Builder create() {
        Builder builder = new Builder();
        builder.result = new example.RutaProtos.Ruta();
        return builder;
      }
      
      protected example.RutaProtos.Ruta internalGetResult() {
        return result;
      }
      
      public Builder clear() {
        if (result == null) {
          throw new IllegalStateException(
            "Cannot call clear() after build().");
        }
        result = new example.RutaProtos.Ruta();
        return this;
      }
      
      public Builder clone() {
        return create().mergeFrom(result);
      }
      
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return example.RutaProtos.Ruta.getDescriptor();
      }
      
      public example.RutaProtos.Ruta getDefaultInstanceForType() {
        return example.RutaProtos.Ruta.getDefaultInstance();
      }
      
      public boolean isInitialized() {
        return result.isInitialized();
      }
      public example.RutaProtos.Ruta build() {
        if (result != null && !isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return buildPartial();
      }
      
      private example.RutaProtos.Ruta buildParsed()
          throws com.google.protobuf.InvalidProtocolBufferException {
        if (!isInitialized()) {
          throw newUninitializedMessageException(
            result).asInvalidProtocolBufferException();
        }
        return buildPartial();
      }
      
      public example.RutaProtos.Ruta buildPartial() {
        if (result == null) {
          throw new IllegalStateException(
            "build() has already been called on this Builder.");
        }
        if (result.segmentos_ != java.util.Collections.EMPTY_LIST) {
          result.segmentos_ =
            java.util.Collections.unmodifiableList(result.segmentos_);
        }
        example.RutaProtos.Ruta returnMe = result;
        result = null;
        return returnMe;
      }
      
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof example.RutaProtos.Ruta) {
          return mergeFrom((example.RutaProtos.Ruta)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }
      
      public Builder mergeFrom(example.RutaProtos.Ruta other) {
        if (other == example.RutaProtos.Ruta.getDefaultInstance()) return this;
        if (other.hasId()) {
          setId(other.getId());
        }
        if (!other.segmentos_.isEmpty()) {
          if (result.segmentos_.isEmpty()) {
            result.segmentos_ = new java.util.ArrayList<example.RutaProtos.SegmentoCaminho>();
          }
          result.segmentos_.addAll(other.segmentos_);
        }
        this.mergeUnknownFields(other.getUnknownFields());
        return this;
      }
      
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          com.google.protobuf.UnknownFieldSet.newBuilder(
            this.getUnknownFields());
        while (true) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              this.setUnknownFields(unknownFields.build());
              return this;
            default: {
              if (!parseUnknownField(input, unknownFields,
                                     extensionRegistry, tag)) {
                this.setUnknownFields(unknownFields.build());
                return this;
              }
              break;
            }
            case 8: {
              setId(input.readInt32());
              break;
            }
            case 18: {
              example.RutaProtos.SegmentoCaminho.Builder subBuilder = example.RutaProtos.SegmentoCaminho.newBuilder();
              input.readMessage(subBuilder, extensionRegistry);
              addSegmentos(subBuilder.buildPartial());
              break;
            }
          }
        }
      }
      
      
      // required int32 id = 1;
      public boolean hasId() {
        return result.hasId();
      }
      public int getId() {
        return result.getId();
      }
      public Builder setId(int value) {
        result.hasId = true;
        result.id_ = value;
        return this;
      }
      public Builder clearId() {
        result.hasId = false;
        result.id_ = 0;
        return this;
      }
      
      // repeated .example.SegmentoCaminho segmentos = 2;
      public java.util.List<example.RutaProtos.SegmentoCaminho> getSegmentosList() {
        return java.util.Collections.unmodifiableList(result.segmentos_);
      }
      public int getSegmentosCount() {
        return result.getSegmentosCount();
      }
      public example.RutaProtos.SegmentoCaminho getSegmentos(int index) {
        return result.getSegmentos(index);
      }
      public Builder setSegmentos(int index, example.RutaProtos.SegmentoCaminho value) {
        if (value == null) {
          throw new NullPointerException();
        }
        result.segmentos_.set(index, value);
        return this;
      }
      public Builder setSegmentos(int index, example.RutaProtos.SegmentoCaminho.Builder builderForValue) {
        result.segmentos_.set(index, builderForValue.build());
        return this;
      }
      public Builder addSegmentos(example.RutaProtos.SegmentoCaminho value) {
        if (value == null) {
          throw new NullPointerException();
        }
        if (result.segmentos_.isEmpty()) {
          result.segmentos_ = new java.util.ArrayList<example.RutaProtos.SegmentoCaminho>();
        }
        result.segmentos_.add(value);
        return this;
      }
      public Builder addSegmentos(example.RutaProtos.SegmentoCaminho.Builder builderForValue) {
        if (result.segmentos_.isEmpty()) {
          result.segmentos_ = new java.util.ArrayList<example.RutaProtos.SegmentoCaminho>();
        }
        result.segmentos_.add(builderForValue.build());
        return this;
      }
      public Builder addAllSegmentos(
          java.lang.Iterable<? extends example.RutaProtos.SegmentoCaminho> values) {
        if (result.segmentos_.isEmpty()) {
          result.segmentos_ = new java.util.ArrayList<example.RutaProtos.SegmentoCaminho>();
        }
        super.addAll(values, result.segmentos_);
        return this;
      }
      public Builder clearSegmentos() {
        result.segmentos_ = java.util.Collections.emptyList();
        return this;
      }
      
      // @@protoc_insertion_point(builder_scope:example.Ruta)
    }
    
    static {
      defaultInstance = new Ruta(true);
      example.RutaProtos.internalForceInit();
      defaultInstance.initFields();
    }
    
    // @@protoc_insertion_point(class_scope:example.Ruta)
  }
  
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_example_SegmentoCaminho_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_example_SegmentoCaminho_fieldAccessorTable;
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_example_SegmentoCaminho_Coordenada_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_example_SegmentoCaminho_Coordenada_fieldAccessorTable;
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_example_Ruta_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_example_Ruta_fieldAccessorTable;
  
  public static com.google.protobuf.Descriptors.FileDescriptor
      getDescriptor() {
    return descriptor;
  }
  private static com.google.protobuf.Descriptors.FileDescriptor
      descriptor;
  static {
    java.lang.String[] descriptorData = {
      "\n\rexample.proto\022\007example\"\233\002\n\017SegmentoCam" +
      "inho\022\n\n\002id\030\001 \002(\005\0222\n\004tipo\030\002 \002(\0162$.example" +
      ".SegmentoCaminho.TipoCaminho\022\014\n\004nome\030\003 \001" +
      "(\t\0223\n\006inicio\030\004 \002(\0132#.example.SegmentoCam" +
      "inho.Coordenada\0220\n\003fin\030\005 \002(\0132#.example.S" +
      "egmentoCaminho.Coordenada\032*\n\nCoordenada\022" +
      "\r\n\005pos_x\030\001 \002(\003\022\r\n\005pos_y\030\002 \002(\003\"\'\n\013TipoCam" +
      "inho\022\013\n\007AVENIDA\020\000\022\013\n\007ESTRADA\020\001\"?\n\004Ruta\022\n" +
      "\n\002id\030\001 \002(\005\022+\n\tsegmentos\030\002 \003(\0132\030.example." +
      "SegmentoCaminhoB\014B\nRutaProtos"
    };
    com.google.protobuf.Descriptors.FileDescriptor.InternalDescriptorAssigner assigner =
      new com.google.protobuf.Descriptors.FileDescriptor.InternalDescriptorAssigner() {
        public com.google.protobuf.ExtensionRegistry assignDescriptors(
            com.google.protobuf.Descriptors.FileDescriptor root) {
          descriptor = root;
          internal_static_example_SegmentoCaminho_descriptor =
            getDescriptor().getMessageTypes().get(0);
          internal_static_example_SegmentoCaminho_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_example_SegmentoCaminho_descriptor,
              new java.lang.String[] { "Id", "Tipo", "Nome", "Inicio", "Fin", },
              example.RutaProtos.SegmentoCaminho.class,
              example.RutaProtos.SegmentoCaminho.Builder.class);
          internal_static_example_SegmentoCaminho_Coordenada_descriptor =
            internal_static_example_SegmentoCaminho_descriptor.getNestedTypes().get(0);
          internal_static_example_SegmentoCaminho_Coordenada_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_example_SegmentoCaminho_Coordenada_descriptor,
              new java.lang.String[] { "PosX", "PosY", },
              example.RutaProtos.SegmentoCaminho.Coordenada.class,
              example.RutaProtos.SegmentoCaminho.Coordenada.Builder.class);
          internal_static_example_Ruta_descriptor =
            getDescriptor().getMessageTypes().get(1);
          internal_static_example_Ruta_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_example_Ruta_descriptor,
              new java.lang.String[] { "Id", "Segmentos", },
              example.RutaProtos.Ruta.class,
              example.RutaProtos.Ruta.Builder.class);
          return null;
        }
      };
    com.google.protobuf.Descriptors.FileDescriptor
      .internalBuildGeneratedFileFrom(descriptorData,
        new com.google.protobuf.Descriptors.FileDescriptor[] {
        }, assigner);
  }
  
  public static void internalForceInit() {}
  
  // @@protoc_insertion_point(outer_class_scope)
}
